#!/usr/bin/perl
use strict;
use warnings;

use Test::More tests => 7;
use Data::Dump qw(dump);

use lib 'lib';

use_ok 'APKPM::Store';

ok my $o = APKPM::Store->new, 'new';

ok my $r = $o->insert('job',{
_table => 'adsl',
ip => '127.0.0.1',
username => 'nobody',
ATTNRX => "36.5",
ATTNTX => "17.8",
MAXRX  => 13500,
MAXTX  => 880,
PWRRX  => "0.0",
PWRTX  => "12.6",
RX     => 8500,
SNRRX  => "11.4",
SNRTX  => "16.0",
TX     => 798,
}), 'ADSL';
diag dump($r);

ok my $r = $o->insert('job',{
_table => 'ping',
ip => '127.0.0.1',
username => 'nobody',
rtt => 0.042,
}), 'ping';
diag dump($r);

ok my $r = $o->sql('job', "select username,rtt from ping limit 2"), 'sql';
diag dump($r);

ok my $r = $o->sql('job', "select xx from fake"), 'sql with error';
ok exists $r->{error}, 'error';
diag dump($r);
